(This file public domain.  Originally written by Norbert Preining and
Karl Berry, 2010.)

<p><b>tlmgr 79639 (released 12jul26):</b>
<li>attempt to recover from horrible tlmgr --machine-readable error
trying to download the new Catalogue database from the net,
where it does not (and doesn't need to) exist.

<p><b>tlmgr 79591 (released 10jul26):</b>
<li>prepare for separating Catalogue information from main tlpdb;
no user-visible changes intended.

<p><b>tlmgr 79491 (released 1jul26):</b>
<li>report collections that have been forcibly removed, instead of warning.
<li>when finding dependencies, ignore collections that are dependencies
of a package.

<p><b>tlmgr 78616 (released 13jun26):</b>
<li>tlmgr check executes: recognize xetex.
<li>usual config.guess and curl-ca-bundle.crt updates.
<li>internal debugging and doc updates.

<p><b>tlmgr 78301 (released 7mar26):</b>
<li>tlmgr info longdesc warning/bug fixed.

<p><b>2mar26 TL'26 released.</b>

<p><b>tlmgr 77655 (released 7feb26):</b>
<li>tlmgr doc update.
<li>tlmgr: more debugging output if Master directory not found.
<li>fmtutil, updmap: make self-locating as with tlmgr.

<p><b>tlmgr 76773 (released 6nov25):</b>
<li>check for backup container creation failure.

<p><b>infra 75588 (released 24jun25):</b>
<li>add utf8runscript.exe to texlive.infra, for better UTF-8 support on
some Windows scripts.

<p><b>tlmgr 75204 (released 14may25):</b>
<li>report more info when remote database is older than local installation.
<li>update GPG key rings.

<p><b>tlmgr 74695 (released 19mar25):</b>
<li>in --usermode, do not warn about texlive-scripts being missing.

<p>8mar25 TL'25 released.

<p><b>tlmgr 74241 (released 24feb25):</b>
<li>doc-only update: tlmgr paper rebuilds existing formats.

<p><b>tlmgr 73493 (released 17jan25):</b>
<li>new option --only-files for tlmgr info to just report files of a package.

<p><b>TLUtils.pm 71593 (released 23jun24):</b>
<li>typo caused tlmgr install --file to fail.

<p><b>tlmgr 71331 (released 18jun24):</b>
<li>tlmgr search: format to avoid Perl warnings.

<p><b>tlmgr 71079 (released 27apr24):</b>
<li>tlmgr search accepts --json option.
<li>Windows: Visual Basic usage in uninstall-windows and runscript.tlu
has been replaced by Powershell, since VB is optional as of Windows 11.

<p><b>tlmgr 70671 (released 30mar24):</b>
<li>wording of platform messages.
<li>revert xz binaries to older versions.
<li>run mtxrun --script fonts --reload when ConTeXt is updated.
<li>updmap creates the generically-named output files as copies by default.

<p><b>tlmgr 70080 (released 25feb24):</b>
<li>new action "bug" to output bug-reporting information.

<p><b>tlmgr 69686 (released 7feb24):</b>
<li>prune tlpdb backups of tlcontrib (now mirrored).

<p><b>tlmgr 69653 (released 1feb24):</b>
<li>redirect output from context cache updates to tlmgr-commands.log.

<p><b>tlmgr 69413 (released 15jan24):</b>
<li>refrain from updating if the remote repository is older than the current
    installation; this is checked via the texlive-scripts package revision.
<li>use our own root certificate bundle on all platforms, to support LWP
    more widely, notably on macOS.

<p><b>tlmgr 66903 (released 20nov23):</b>
<li>message wording.

<p><b>tlmgr 66818 (released 15nov23):</b>
<li>detect a remote repository older than the local installation (i.e.,
    a stale mirror), and don't update, to avoid incorrect package removals.
<li>warn if a file or directory could not be removed.
<li>the installer's curl-ca-bundle.crt updated.

<p><b>tlmgr 66798 (released 11apr23):</b>
<li>base context cache regeneration on ls-R mtimes.
<li>support context paper size setting.

<p>TeX Live 2023 released.

<p><b>tlmgr 66457 (released 8mar23):</b>
<li>tweaking context cache generation commands.

<p><b>tlmgr 66236 (released 28feb23):</b>
<li>run both mtxrun --generate and context --luatex --generate
as post-update actions, if the luametatex binary is operational.

<p><b>tlmgr 66218 (released 27feb23):</b>
<li>rename "path --w32mode" option to --windowsmode; similar throughout.

<p><b>tlmgr 63033 (released 17apr22):</b>
<li>tlmgr check files also ignores the tlmgr*.log files.
<li>document that in user mode, tlmgr*.log are written to TEXMFVAR.

<p><b>install-tl 63001 (released 11apr22):</b>
<li>default to the text interface on Darwin.
<li>disk space checking implemented for Windows.

<p><b>install-tl 62504 (released 7mar22):</b>
<li>install core packages first, retry other packages once.
<li>basic check for enough disk free, given a working df -P.
<li>catch interrupt signals and exit immediately.

<p><b>tlmgr 62273 (released 28feb22, pretest):</b>
<li>update description for armhf-linux; fix typos.

<p><b>tlmgr 61401 (released 8feb22):</b>
<li>on darwin, use our own curl cert bundle (now updated),
    to try to avoid cert expiration problems, since Apple will not fix
    old versions
    (<a href="https://savannah.nongnu.org/forum/forum.php?forum_id=10054"
     >background</a>,
     <a href="https://tug.org/pipermail/tex-live/2021-November/047540.html"
     >symptom</a>).
<li>avoid creating file named "nul" on Windows when checking mirror status.
<li>implementation: use strict; use warnings; for Perl modules.

<p><b>tlmgr 60693 (released 12oct21):</b>
<li>use TEXMFROOT instead of SELFAUTOPARENT to allow easier relocating
    (<a href="https://tug.org/pipermail/tex-live/2021-September/047394.html"
     >thread</a>).

<p><b>tlmgr 60557 (released 20sep21):</b>
<li>omit &ldquo;done running&rdquo; line for fmtutil.
<li>allow : to separate argument values as well as , to placate powershell.
<li>config.guess: back to `...`. Whew.

<p><b>tlmgr 59208 (released 15may21):</b>
<li>still trying to optimize the ssl multiplexor resolution.

<p><b>tlmgr 59154 (released 10may21):</b>
<li>more adaptations for https://mirror.ctan.org (and again on 14may21).

<p><b>tlmgr 59108 (released 7may21):</b>
<li>support, and prefer, curl for https://mirror.ctan.org resolution.
<li>don't require valid ssl certificates since we can't always support ssl.

<p><b>tlmgr 58938 (released 21apr21):</b>
<li>adapt to https://mirror.ctan.org now being available.
<li>when install option create_formats=0, only refresh existing formats.

<p>TeX Live 2021 released.

<p><b>tlmgr 57705 (released 12feb21):</b>
<li>use pure Perl solution to rmdir TL tree for uninstall.

<p><b>tlmgr 57424 (released 16jan21):</b>
<li>usermode: pass -user to fmtutil.
<li>remove dependency on File::Copy.

<p><b>tlmgr 57119 (released 13dec20):</b>
<li>keep only one backup of the main repo's <tt>texlive.tlpdb</tt>,
regardless of which mirror is used.

<p><b>tlmgr 56566 (released 8oct20):</b>
<li>avoid tlmgr info --data printing incorrect relocatable data.
<li>tlmgr restore: ensure depending formats are rebuilt.
<li>Windows: support batch uninstallation by passing any argument.
<li>Windows: silence spurious warnings due to failures in broadcast_env.

<p><b>tlmgr 56458 (released 30sep20):</b>
<li>tlmgr info reports new lcat-* and rcat-* fields for local vs. remote data.

<p><b>tlmgr 56372 (released 22sep20):</b>
<li>small fixes for warnings, csv output, xdvi paper location.

<p><b>tlmgr 55369 (released 1jun20):</b>
<li>full logging of subcommands moved to new file tlmgr-commands.log.

<p><b>tlmgr 54446 (released 21mar20):</b>
<li>full logging of subcommand (notably fmtutil) output in tlmgr.log.
<li>tlmgr update --all --force does not update tlperl.w32.
<li>tlmgr -gui uninstall of entire TL fixed.

<p><b>tlmgr 54286 (released 13mar20):</b>
<li>tlmgr remove --all also removes install-tl and texmfcnf.lua.

<p><b>tlmgr 54118 (released 7mar20):</b>
<li>re-initialize LWP connection after 5 errors.
<li>more specific verification error messages.

<p><b>tlmgr 53428 (released 17jan20):</b>
<li>automatic retry of packages that fail to download.
<li>rearrange packaging so little-used scripts are not part of
infraonly; remove tetex package.

<p><b>tlmgr 53225 (released 25dec19):</b>
<li>avoid doubled .rNNN in backup container names.
<li>warning when chosen installation root (TEXDIR) has problematic characters.
<li>silence check texmfdbs by default; refine checks.
<li>omit catalogue-date entry when packages are updated.
<li>debugging output when a directory is failed to be collapsed for backup tar.

<p><b>tlmgr 52931 (released 27nov19):</b>
<li>major change to <a
href="https://tug.org/texlive/tlmgr.html#verpkg">versioned package
containers</a> for the central tlnet repository.

<p><b>tlmgr 52752 (released 12nov19):</b>
<li>TLConfig.pm: luahbtex binary missing on some platforms until TL'20.

<p><b>tlmgr 52585 (released 31oct19):</b>
<li>TLUtils.pm: try again with symlink change for backups.
<li>small doc and implementation improvements.

<p><b>tlmgr 52467 (released 21oct19):</b>
<li>revert TLUtils.pm change, as it could cause symlinks to absolute paths
to be in the bin/ directories, not just used for backups.

<p><b>tlmgr 52123 (released 20oct19):</b>
<li>tlmgr check runfiles: ignore latex-.*-dev packages.
<li>reduce download retries for curl and wget from 10 to 4.
<li>TLUtils.pm: prepare for versioned containers by making symlinks absolute.

<p><b>tlmgr 51555 (released 5jul19):</b>
<li>runscript.tlu: use vbscript for GUI error boxes, so tlshell can be
its own self-contained package, entirely separate from texlive.infra.

<p><b>tlmgr 51217 (released 29may19):</b>
<li>propagate gpg verification status for GUIs.

<p><b>tlmgr 50796 (released 7apr19):</b>
<li>more runscript.tlu and doc tweaks; TL'19 release.

<p><b>tlmgr 49885 (released 6feb19):</b>
<li>runscript.tlu support for tclkit and GUI errors; only doc tweaks for
tlmgr itself.

<p><b>tlmgr 49226 (released 23nov18):</b>
<li>new environment variable TEXLIVE_PREFER_OWN to prefer compression
(e.g., xz) and download (e.g., wget) programs shipped with TL to those
provided by the system.

<p><b>tlmgr 48598 (released 29oct18):</b>
<li>remove debugging line for caller() left in by mistake.
<li>update ctan backbone list (to the one remaining).

<p><b>tlmgr 48522 (released 3sep18):</b>
<li>tlmgr info: report Catalogue contact info if available.
<li>only run mtxrun if luatex is available.

<p><b>tlmgr 48271 (released 25jul18):</b>
<li>prefer system provided binaries over TL provided binaries for
  compressor and download programs.
<li>tlmgr info now allows listing only packages from the remote 
  repository using <tt>--only-remote</tt>.
<li>further checks on downloaded signature files to reduce
  spurious warnings.
<li>save alias information from TeX Catalogue.

<p><b>tlmgr 47951 (released 07jun18):</b>
<li>Backup removal for non-xz.

<p><b>tlmgr 47935 (released 05-06jun18):</b>
<li>Bug fix for lz4 backups (need <tt>-m</tt> for normal behavior).

<p><b>tlmgr 47907 (released 03jun18):</b>
<li>support for curl as a download program, and new default behavior for
choosing. In this order:
  <ol>
  <li>If the environment variable <tt>TEXLIVE_DOWNLOADER</tt> is
      defined, use it; abort if the specified program doesn't work.
      Possible values: <tt>curl</tt>, <tt>wget</tt>.
  <li>If the environment variable <tt>TL_DOWNLOAD_PROGRAM</tt> is
      defined (can be any value), use it together with
      <tt>TL_DOWNLOAD_ARGS</tt>; abort if it doesn't work.
  <li>If LWP is available and working, use that (by far the most
      efficient method, as it supports persistent downloads).
  <li>If curl is available (from the system) and working, use that.
  <li>If wget is available (either from the system or TL) and
      working, use that.
  </ol>
  <p>TL still provides <tt>wget</tt> binaries for some platforms, so
  some download method should always be available.
  
<li>support for alternative compressor programs; until now, backups and
  intermediate rollback containers were always created with xz. Now:
  <ol>
  <li>If the environment variable <tt>TEXLIVE_COMPRESSOR</tt> is
      defined, use it; abort if it doesn't work. Possible values:
      <tt>lz4</tt>, <tt>gzip</tt>, <tt>xz</tt>.
  <li>If lz4 is available (either from the system or TL) and working, use that.
  <li>If gzip is available (from the system) and working, use that.
  <li>If xz is available (either from the system or TL) and working, use that.
  </ol>
  <p>lz4 and gzip are much faster in creating tlmgr's local backups.
  The unconditional use of xz for the tlnet containers is unaffected,
  to minimize download sizes.

<li><a href="https://openssh.com/">ssh</a> support: installing from a
  repository of the form <tt>user@machine:/path/to/tlnet</tt> is now
  supported; the url-like forms
  <tt>scp://user@machine/path/to/tlnet</tt> and
  <tt>ssh://user@machine/path/to/tlnet</tt> are equivalent. ssh-agent
  is strongly recommended!

<li>Not tlmgr, but close enough: our generic Windows wrapper
runscript.tlu now sets <tt>LC_CTYPE</tt> to be the system encoding, to
support files with non-ASCII characters.

<p><b>tlmgr 47303 (released 14apr18):</b>
<li>uninstall now a synonym for remove, so requiring --all to remove the
TeX&nbsp;Live installation.

<p><b>tlmgr 46207 (released 31jan18):</b>
<li>new action/option print-platform-info to dump platform name(s) as
  well as the identifier.
<li>fix integrity checks to include checksum and not only size.
<li>remove support for md5 checksums (unused for a long time).

<p><b>tlmgr 46034 (released 12dec17):</b>
<li>tlmgr info (list): reinstate previous (and intended) list format.
<li>tlmgr info: only load remote tlpdb when necessary.
<li>(Windows) do not run post-actions when luatex.dll is not
  available (because runscript needs luatex).

<p><b>tlmgr 45838 (released 23nov17):</b>
<li>allow excluding packages from update in tlmgr config file.
<li>JSON output for various commands.
<li>other machine-readable improvements.

<p><b>tlmgr 45286 (released 15sep17):</b>
<li>require the main repository to be signed.
<li>fix tlmgr info output.

<p><b>tlmgr 45190 (released 1sep17):</b>
<li>fix tlmgrgui not to switch to single repo mode on CTAN mirror usage.
<li>prohibit upgrades between releases using tlmgr.
<li>add shell mode.
<li>add tabulated info output.

<p><b>tlmgr 44452 (released 9jun17):</b>
<li>bug fix for tlmgr conf editing of line continuations.

<p><b>tlmgr 44422 (TeX Live 2017):</b>
<li>new action <tt>shell</tt> for interactive and scripted use.
<li>new action <tt>conf auxtrees</tt> to easily add and remove extra
  texmf trees.
<li>if backups are enabled, a backup is automatically made by the
  <tt>remove</tt> action.
<li>the <tt>info</tt> output includes sizes for schemes and collections.

<p><b>tlmgr 41476 (released 20jun16):</b>
<li>fix <tt>tlmgr restore</tt> failure

<p><b>tlmgr 41258 (TeX Live 2016, 19may16):</b>
<li>support for system-level configuration files in 
<tt>TEXMFSYSCONFIG/tlmgr/config</tt>, where a restricted set of allowed
actions can be defined, in addition to the usual tlmgr config file
directives.
<li>the font and other gui controls can be specified as options to the
<tt>gui</tt> action.
<li>verify package checksums during installation; sha-512 used instead
of md5 for checksums; new config file setting <tt>no-checksums</tt>.
<li>gpg verification supported, with new action <tt>key</tt> and new
options and config settings <tt>--require-verification</tt> and
<tt>verify-downloads</tt>.
<li>unify installer and tlmgr package installation implementations.

<p><b>tlmgr revision 39198 (released 5jan16):</b>
<li>message and doc changes.
<li>ConTeXt paper size changes.

<p><b>tlmgr revision 37738 (released 3jul15):</b>
<li>more accurate error codes, e.g., for paper sizes.
<li>info searches titles, descriptions, file names, topics if available.

<p><b>tlmgr revision 37030 (released 24apr15):</b>
<li>more reliable exit status codes.
<li>add --with-doc and --with-src options for use with install --reinstall,
to get the doc and/or src files even if they were omitted at initial
installation.
<li>the install action reports explicitly-requested packages already installed.
<li>restore --dry-run is now more of a no-op, as intended.

<p><b>tlmgr revision 35841 (released 24dec14):</b>
<li>remove taxonomy searching, since upstream data is no longer maintained.

<p><b>tlmgr revision 34227 (released 23may14, TeX Live 2014):</b>
<li>If the NOPERLDOC envvar is set, avoid fancy <tt>--help</tt> message
formatting, regardless.  (Same holds for install-tl.)
<li><tt>tlmgr conf</tt> supports new options <tt>--delete</tt>,
<tt>--conffile</tt>, and <tt>updmap</tt>.
<li>doc and error checking updates as usual.

<p><b>tlmgr revision 32912 (released 9feb14):</b>
<li>tlmgrgui wordings, arrangements, etc.

<p><b>tlmgr revision 31657 (released 15sep13):</b>
<li>fix for "quoted" strings inside doc attributes, as in pythontex's
Catalogue entry.

<p><b>tlmgr revision 31400 (released 9aug13):</b>
<li>fix for installation from file (install --file).

<p><b>tlmgr revision 30643 (released 23may13, TeX Live 2013):</b>
<li>documentation updates for the release.
<li>new tlperl (version 5.16.2) for Windows, compiled without
    optimization and with debugging

<p><b>tlmgr revision 28216 (released 09nov12):</b>
<li>menu shortcuts are installed unconditionally, the desktop_integration
    option only controls shortcuts on the desktop (W32)
<li>fix --self updates on W32 when multiple remote repositories are used

<p><b>tlmgr revision 27748 (released 25oct12):</b>
<li>support <tt>tlmgr repository list ...</tt> for listing of any repository
<li>work around Cygwin Perl returning undef from an empty file

<p><b>tlmgr revision 27601 (released 07sep12):</b>
<li>allow for spaces in the repository path (again)
<li>make <tt>tlmgr --help</tt> more robust against broken perldoc

<p><b>tlmgr revision 27413 (released 16aug12):</b>
<li>fix Perl syntax warning in trans.pl
<li><tt>tar -m</tt> in Windows update to avoid spurious problems

<p><b>tlmgr revision 27258 (released 30jul12):</b>
<li>more fixes to updmap multi-tree support for TEXMFLOCAL

<p><b>tlmgr revision 27170 (released 26jul12):</b>
<li>consistently use ll_RR in .po file naming, per general gettext convention
<li>make sure that an outdated updmap.cfg file is backed up and removed

<p><b>texlive.infra (tlmgr) revision 26923 (released 07jul12):</b>
<li>version with TeX Live 2012
<li>generate updmap is no more, since updmap.cfg is now per-tree
<li>multiple repository support
<li>tlmgr can now install a package from a file

<p><b>tlmgr revision 24419 (released 01nov11):</b>
<li>support addKanjiMap execute

<p><b>tlmgr revision 23514 (released 12aug11):</b>
<li>dependent formats are regenerated when necessary.
<li>on Windows only, do not update time stamps when unpacking,
    to partially avoid spurious errors.
<li>detect mipsel and mipsel64 platforms.

<p><b>tlmgr revision 23117 (released 23jun11):</b>
<li>version with TeX Live 2011.
<li>support <tt>gui-lang</tt> in tlmgr config file, and add GUI
    interface for it.

<p><b>tlmgr revision 20975 (released 24jan11):</b>
<li>fix usage of persistent connections in tlmgr.
<li>override locale settings when using wget as a subprocess.

<p><b>tlmgr revision 20243 (released 1nov10):</b>
<li>try (again) not to load the remote tlpdb if tlmgr update is called
    without arguments.
<li>fix bugs in autobackup/backupdir handling; unify error messages;
    on clean, also remove package backups for packages no longer present
    in tlpdb.
<li>support keyword searching as provided by the beta CTAN characterizations
    at <a href="http://az.ctan.org/">http://az.ctan.org/</a> (no Internet
    access needed for the search, though).  tlmgr documentation 
    has details. Support is also present in tlmgrgui.

<p><b>tlmgr revision 19923 (released 28sep10):</b>
<li>undo change for not loading remote db, needs more work.

<p><b>tlmgr revision 19896 (released 27sep10):</b>
<li>add <tt>-R</tt> to the <tt>LESS</tt> environment variable, and unset
    LESSOPEN and LESSPIPE, before calling pod2usage.
<li>don't load the remote db if tlmgr update is called without arguments.

<p><b>tlmgr revision 19414 (TeX Live 2010 release version):</b>
<li>implement download selection mode in the file
    <tt>TEXMFCONFIG/tlmgr/config</tt>,
    option <tt>persistent-downloads</tt>, with value 0 or 1.
<li>remove support for old GUI (<tt>tlmgr gui-old</tt>).

tlmgr rev 17811 (2010-04-25)
  * tlmgr restore --all: restoring the latest, using all available backups.
  * GUI: add support for restore action.
  * do not auto-install packages contained in forcibly removed collections.
  * GUI: add support for the three command line options: --no-auto-install,
    --no-auto-remove (under Menu->Options), and --reinstall-forcibly-removed
    (just below the "Update all installed" button).
  * GUI: provide access to the manual (tlmgr help) in the Help menu
  * GUI: provide simple and expert modes (Options->Expert options)

tlmgr rev 17611 (2010-03-30)
  * Support automatic installation of new collections (when they are 
    included in the selected scheme). 

tlmgr rev 17455 (2010-03-19)
  * persistent HTTP connections enabled by default 
    (use --no-persistent-downloads to turn off)
  * package update algorithm changed to avoid incorrect
    "forcibly removed" inferences. Should be invisible.
  * report of the number of pending updates in tlmgr gui. 
